%define name        glibc
%define ver         2.1.3
%define rel         38
%define prefix      /usr
%define serial	    2003040201

Summary: GNU libc
Name:		%{name}
Version:	%{ver}
Release:	%{rel}
Group: System Environment/Libraries
Serial: %{serial}
Copyright: LGPL
Source0: glibc-2.1.3.tar.bz2
Source1: http://www.ozemail.com.au/~geoffk/glibc-crypt/glibc-crypt-2.1.1.tar.gz
Source2: glibc-compat-2.1.2.tar.gz
Source3: glibc-2.1-nsswitch.conf
Source4: glibc-linuxthreads-2.1.3.tar.gz
Source7: glibc-2.1.3.po.gz
Source8: glibc-2.1.3-gconv-modules.patch.gz
Source9: tzdata2000h.tar.gz

Patch0: glibc-2.1-rhpaths.patch
Patch1: glibc-2.1-cppfix.patch
Patch2: glibc-sharedir.patch
Patch3: glibc-2.1.3-bufend.diff
Patch4: glibc-2.1-thrlock.patch
Patch5: glibc-2.1.2-locale.patch
Patch6: ftp://ftp.linux-ipv6.org/pub/usagi/snap/patch/glibc21-2.1.3-usagi-20010108.patch
Patch7: glibc-2.1.3-enUSlocale.patch
Patch8: glibc-2.1.3-x86-lfs.patch
Patch9: glibc-2.1.3-locale.alias-ko.patch

# Update patch(es)
Patch10: glibc-2.1.3-pthreadfix.patch
Patch11: glibc-2.1.3-dlerror.patch
Patch12: glibc-2.1.3-dl-open.patch
Patch13: glibc-2.1.3-dl-close.patch
Patch14: glibc-2.1.3-preload.patch
Patch15: glibc-2.1.3-netscape.patch
Patch16: glibc-2.1.3-locale.patch

# S390 patches
Patch20: glibc-2.1.3.3-s390.diff
Patch21: glibc-linuxthreads-2.1.3.3-s390.diff

# RS6000 IBM PPC Patches
Patch22: glibc-2.1.3-mach1.patch

# Timezone patches
Patch31: glibc-2.1.3-zonetab.patch

# XDR buffer overflow patch
Patch32: glibc-%{version}-xdr_array.patch
Patch33: glibc-2.2.4-security.patch

# calloc buffer overflow
Patch34: glibc-2.1.3-calloc.patch

# resolver buffer overflow
Patch35: glibc-2.1.3-maxpacket.patch

Patch36: glibc-2.1.3-xdrmem.patch

BuildRoot: /var/tmp/%{name}-%{ver}-root
PreReq: /sbin/ldconfig, filesystem
Obsoletes: zoneinfo, libc-static, libc-devel, libc-profile, libc-headers,
Obsoletes: linuxthreads, gencat, locale
Autoreq: false

#NoSource: 0
#NoSource: 1
#NoSource: 2
#NoSource: 3
#NoSource: 4
#NoSource: 7
#NoSource: 8
#NoSource: 9
#NoPatch: 6

%ifarch alpha
Provides: ld.so.2
%else
%endif
%ifarch sparc
Obsoletes: libc
%endif

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a
Linux system will not function. It also contains national language (locale)
support and timezone databases.

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries
Conflicts: texinfo < 3.11
Prereq: /sbin/install-info
Obsoletes: libc-debug, libc-headers, libc-devel, linuxthreads-devel
Obsoletes: glibc-debug
Prereq: kernel-headers, /bin/sh
Requires: kernel-headers >= 2.2.1
Autoreq: true

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%package profile
Summary: glibc with profiling support
Group: Development/Libraries
Obsoletes: libc-profile
Autoreq: true

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%package -n nscd
Summary: Name Service Caching Daemon
Group: System Environment/Daemons
Conflicts: kernel < 2.2.0
Prereq: /sbin/chkconfig, /bin/sh
Autoreq: true

%description -n nscd
nscd caches name service lookups; it can dramatically improve performance
with NIS+, and may help with DNS as well.

You cannot use nscd with 2.0 kernels, due to bugs in the kernel-side thread
support. nscd happens to hit these bugs particularly hard.

%package -n mtrace
Summary: Tool for tracing malloc()s
Group: Development/Debuggers
Autoreq: true

%description -n mtrace
mtrace is a tool used to trace malloc()'s.

%changelog
* Wed Apr 2 2003 Jun YOSHIDA <jun@miraclelinux.com>
- fixed xdr security bug.

* Tue Nov 19 2002 Jun YOSHIDA <jun@miraclelinux.com>
- fixed resolver beffer overflow.

* Mon Aug 26 2002 Jun YOSHIDA <jun@miraclelinux.com>
- applied calloc patch.

* Wed Aug 7 2002 Jun YOSHIDA <jun@miraclelinux.com>
- applied XDR buffer overflow patch.

* Mon Apr 02 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- added glibc-2.1.3-locale.patch to fix security vulnerability. (patch 16)

* Wed Feb 28 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Sync new timezone information (from ftp://elsie.nci.nih.gov/pub/)
- Modified a mistake in zone.tab in timezone.

* Thu Feb  8 2001 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- add korea alias (patch9) 

* Thu Feb  8 2001 SL Baur  <steve@turbolinux.co.jp>
- add patch to bandaid over a netscape crash

* Tue Feb  6 2001 SL Baur  <steve@turbolinux.co.jp>
- replace bash dependencies with /bin/sh dependencies
- fix some spec file documentation
- remove Korean locale

* Mon Jan 22 2001 Takeshi Aihana <aihana@turbolinux.co.jp>
- fix name and file for patch6

* Sat Jan 20 2001 Borut Lukic <borut@turbolinux.com>
- Added support for Power3 PPC

* Fri Jan 19 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- fix LD_PRELOAD security bug.

* Fri Jan 12 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated IPv6 patch. (usagi snap = 20010108)

* Sun Dec 31 2000 Roger Luethi <rluethi@turbolinux.com>
- 2.1.3-24: s390 support
- add glibc-2.1.3.3-s390.diff, glibc-linuxthreads-2.1.3.3-s390.diff
- portable way to determine number of CPUs (SMP variable)
- fixed typo with source glibc-2.1.3-gconv-modules.patch.gz

* Mon Dec 25 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Modified info directory in %%post section script from /usr/info to /usr/share/info.
- Removed IPv6 patch temporarily.

* Thu Dec 14 2000 SL Baur  <steve@turbolinux.co.jp>
- add patch for backported gconv modules for GB18030 and BIG5HKSCS

* Tue Dec 12 2000 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- added filesystem as PreRequite

* Fri Dec 8 2000 Go Taniguchi <go@turbolinux.co.jp>
- added lfs patch

* Thu Dec  7 2000 SL Baur  <steve@turbolinux.co.jp>
- add dynamic library fixes (patch11 .. patch13)

* Sat Dec  2 2000 SL Baur  <steve@turbolinux.co.jp>
- fix directory ownerships

* Thu Oct 26 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated USAGI IPv6 patch (20001101a).
- Added README.USAGI document file.

* Thu Oct 19 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- IPv6 patch updated (20001010a_20001016)

* Wed Oct 18 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Fixed en_US localedata. When "rm -i file", and return "s" in question, file is removed.

* Fri Oct 13 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated IPv6 patch to 2000-10-12.

* Tue Oct 10 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added IPv6 patch.

* Mon Sep  4 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added glibc-2.1.3-pthreadfix.patch to fix locale related security.

* Fri Aug 11 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Removed bash entry from PreReq: section in glibc (main) package.
- Added bash entry to PreReq: section in glibc-devel and nscd package.

* Tue Aug 08 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Removed Japanese locales from glibc package. Japanese locales
  contain glibc-locale package.

* Sun May 21 2000 Takeshi Aihana <aihana@turbolinux.co.jp>
- modified %post, %preun of develop package

* Wed Mar 01 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added Japanese locale

* Mon Feb 28 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to glibc-2.1.3

* Fri Feb 28 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added patch for textarea in Netscape Navigator.

* Mon Feb  7 2000 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- updated tl-localdata ( added new GB localedata, made a link
- ja_JP.eucJP -> ja_JP.ujis )

* Tue Nov 16 1999 Ki-ichiroh Naka <knaka@turbolinux.co.jp>
- removed /etc/localtime. it is to be generated by a config-tool

* Mon Sep 27 1999 Kelley Spoon <kelley.spoon@turbolinux.com>
- ok... scsi is back in again (was a while back, actually)
  kernel is going to concede /usr/include/scsi to glibc-devel

* Thu Aug 26 1999 Kelley Spoon <kspoon@turbolinux.com>
- we're moving back to egcs-1.1.2 as the main compiler for TL 4.1
- bumped to glibc-2.1.2pre3 (also upgraded linuxthreads)
- split mtrace (perl script) off into its own package to prevent
  glibc from requiring perl  :-) 

* Sun Aug 22 1999 Kelley Spoon <kspoon@turbolinux.com>
- built with gcc 2.95.1 on kernel 2.2.11
- removed references to /usr/include/scsi in rpm list

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- update for 2.1.2, the stable release of 2.1
- remove the patch that switched vfork with fork in libio/iopoen, as this
  should be handled now by a different patch
- statvfs patch no loger needed
- upgraded glibc-compat to 2.1.2 to address the __setfpucw problem (#3468)
- /etc/localtime is not a sylink anymore (#3816)
- add patch to implement xdr_ypall (#249)
- patch to link db_dump185 against the right db library (libdb1) (#2972)
- patch to fix the libpthread compatibility problem (#3738)
- patch to fix threads on SMP (#3693)
- patch to fix nscd alignment problem on the sparc (#3171)
- fix the bits/string.h header to stop generating compiler warnings.

* Mon Apr 26 1999 Cristian Gafton <gafton@redhat.com>
- alpha patches from Jay Estabrook to support the RX164

* Wed Apr 14 1999 Cristian Gafton <gafton@redhat.com>
- new CVS update - some patches dropped out
- updated obsoletes tag lines
- patch for the ukraine support

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- add patch for libstdc++ 2.7.2 (enable __dup, __pipe and __waitpid)
- linuxthread patch from HJLu
- add patch to make nscd respond to SIGHUP by dumping the cache

* Wed Apr 07 1999 Cristian Gafton <gafton@redhat.com>
- updated from cvs tree
- add patch for fstatvfs from HJLu

* Thu Apr 01 1999 Cristian Gafton <gafton@redhat.com>
- opentty fix
- don't call lddlibc4 on sparcs

* Thu Mar 25 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1.1
- make nscd run by default at init
- nscd subpackage
- let the subpackages autoreq their own thing

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1
- strip binaries installed by default

* Thu Feb 18 1999 Cristian Gafton <gafton@redhat.com>
- updated snapshot
- glibc-crypt might have export problems (who knows?), so we are nosource
  iit for now

* Wed Feb 03 1999 Cristian Gafton <gafton@redhat.com>
- version 2.0.112
- merge glibc-debug into glibc-devel
- new compat add-on

* Wed Jan 13 1999 Cristian Gafton <gafton@redhat.com>
- new glibc-crypt add-on
- version 2.0.109
- handle /etc/localtime separately
- don't include /usr/share in the file list
- don not build glibc-compat on the arm

* Wed Dec 02 1998 Cristian Gafton <gafton@redhat.com>
- build ver 2.0.105 on all four arches
- enabled /usr/include/scsi as part of the glibc package

* Fri Oct 02 1998 Cristian Gafton <gafton@redhat.com>
- first build for 2.0.96
#-------------------------------------------------------------------------------

%prep
%setup -q -a 1 -a 2 -a 4
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
#%patch6 -p1 -b .ipv6
%patch7 -p1 -b .fix
%patch10 -p1 -b .pthread
%patch11 -p1 -b .dlerror
%patch12 -p1 -b .dl-open
%patch13 -p1 -b .dl-close
%patch14 -p1 -b .preload
%patch15 -p1 -b .netscape
%patch16 -p1 -b .locale
%patch20 -p1 -b .s390
%patch21 -p1 -b .s390

gunzip -c %{SOURCE8} | patch -p1
gzip -dc %{SOURCE9} | tar -xf - -C timezone
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1

perl -pi -e 'm/PACKET.*1024/ and s/1024/65536/' \
    `find resolv glibc-compat -name \*.c`

# For ppc apply patch, and remove 2 files
# It's a hack to compile under Power3 PPC
%ifarch ppc
%patch22 -p0
rm -fv sysdeps/rs6000/memcopy.h
rm -fv sysdeps/powerpc/memset.S
%endif

%ifarch i386 i586 i686
%patch8 -p1 -b .lfs
%endif

%patch9
 
%ifarch armv4l
rm -rf glibc-compat
%endif

find . -type f -size 0 -exec rm -f {} \;

%build
rm -rf build-$RPM_ARCH-linux
mkdir build-$RPM_ARCH-linux ; cd build-$RPM_ARCH-linux
SMP=`grep cpu[[:digit:]] /proc/stat|wc -l`

%ifarch i386
BuildFlags="$RPM_OPT_FLAGS -D__USE_STRING_INLINES"
MYARCH=i586-pc-linux
%endif

if [ -h /usr/include/scsi ]
then
  rm -rf /usr/include/scsi
  mkdir /usr/include/scsi
fi

CFLAGS="-O3 $BuildFlags -g" \
        infodir=\${prefix}/share/info \
	mandir=\${prefix}/share/man \
        ../configure --prefix=/usr \
	--enable-add-ons=yes --without-cvs  \
	$MYARCH

#make -r CFLAGS="-O3 $BuildFlags -g" PARALLELMFLAGS=$SMP
make -r CFLAGS="-O3 $BuildFlags -g"

# make localedata-ja
#cd ../locale-ja-13
#./mkinstalldirs locale/ja/LC_MESSAGES
#../build-$RPM_ARCH-linux/locale/localedef -c -f charmaps/EUC-JP -i ja_JP \
#	-u ../localedata/repertoiremaps/mnemonic.ds locale/ja
#cd ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install_root=$RPM_BUILD_ROOT install -C build-$RPM_ARCH-linux
cd build-$RPM_ARCH-linux && \
    make install_root=$RPM_BUILD_ROOT install-locales -C ../localedata objdir=`pwd` && \
    cd ..

mkdir -p $RPM_BUILD_ROOT/usr/share/locale

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT/usr/lib/libNoVersion*

# the man pages for the linuxthreads require special attention
make -C linuxthreads/man
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man3
install -m 0644 linuxthreads/man/*.3thr $RPM_BUILD_ROOT/usr/share/man/man3

# Move info files
rm $RPM_BUILD_ROOT/usr/info/dir
mv $RPM_BUILD_ROOT/usr/info $RPM_BUILD_ROOT/usr/share/info

ln -sf libbsd-compat.a $RPM_BUILD_ROOT/usr/lib/libbsd.a

install -m 644 $RPM_SOURCE_DIR/glibc-2.1-nsswitch.conf \
	$RPM_BUILD_ROOT/etc/nsswitch.conf

# This is for ncsd - in glibc 2.1
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 nscd/nscd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/nscd

# The database support
mkdir -p $RPM_BUILD_ROOT/var/db
install -m 644 nss/db-Makefile $RPM_BUILD_ROOT/var/db/Makefile

# Strip binaries
strip $RPM_BUILD_ROOT/sbin/* || :
strip $RPM_BUILD_ROOT/usr/bin/* || :
strip $RPM_BUILD_ROOT/usr/sbin/* || :

# Remove Japanese locales from glibc package
rm $RPM_BUILD_ROOT/usr/share/i18n/locales/ja_JP
rm -rf $RPM_BUILD_ROOT/usr/share/locale/ja*

# Remove duplicate Korean locale -- it is in glibc-locale
rm -rf $RPM_BUILD_ROOT/usr/share/locale/ko

# gzip manuals
gzip -9nf $RPM_BUILD_ROOT/usr/share/man/man3/*
gzip -9nf $RPM_BUILD_ROOT/usr/share/info/*

# BUILD THE FILE LIST
find $RPM_BUILD_ROOT -type f -or -type l | 
	sed -e 's|.*/etc|%config(noreplace) &|' > rpm.filelist.in
for n in /usr/share /usr/include; do 
    find ${RPM_BUILD_ROOT}${n} -type d | \
	grep -v '^/usr/share$' | \
	sed "s/^/%attr( 0775,root,root) %dir /" >> rpm.filelist.in
done

# primary filelist
sed "s|$RPM_BUILD_ROOT||" < rpm.filelist.in | 
	grep -v '/etc/localtime'  | \
        grep -v '/usr/bin/mtrace' | \
	sort > rpm.filelist

grep '/usr/lib/lib.*_p\.a' < rpm.filelist > profile.filelist
egrep "(/usr/include)|(/usr/share/info)" < rpm.filelist | 
	grep -v /usr/share/info/dir > devel.filelist

mv devel.filelist devel.filelist.full
grep -v '/usr/include$' < devel.filelist.full |
	grep -v '/usr/share/info$' > devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*_p.a' rpm.filelist.full | 
	egrep -v "(/usr/include)|(/usr/share/info)" > rpm.filelist

grep '/usr/lib/lib.*\.a' < rpm.filelist >> devel.filelist
grep '/usr/lib/.*\.o' < rpm.filelist >> devel.filelist
grep '/usr/lib/lib.*\.so' < rpm.filelist >> devel.filelist
grep '/usr/share/man/man' < rpm.filelist >> devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*\.a' < rpm.filelist.full |
	grep -v '/usr/lib/.*\.o' |
	grep -v '/usr/lib/lib.*\.so'|
	grep -v '/usr/share/man/man' | 
	grep -v '/usr/share$' |
	grep -v '/usr/share/man$' |
	grep -v 'nscd' > rpm.filelist

# /etc/localtime - we're proud of our timezone
# while we are not
#rm -f $RPM_BUILD_ROOT/etc/localtime
#ln -s /usr/share/zoneinfo/US/Eastern $RPM_BUILD_ROOT/etc/localtime

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp linuxthreads/ChangeLog  documentation/ChangeLog.threads
cp linuxthreads/Changes documentation/Changes.threads
cp linuxthreads/README documentation/README.threads
cp linuxthreads/FAQ.html documentation/FAQ-threads.html
cp -r linuxthreads/Examples documentation/examples.threads
cp crypt/README documentation/README.crypt
cp db2/README documentation/README.db2
cp db2/mutex/README documentation/README.db2.mutex
cp timezone/README documentation/README.timezone
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
/sbin/install-info /usr/share/info/libc.info /usr/share/info/dir

%preun devel
if [ "$1" = "0" ]; then
    /sbin/install-info --delete /usr/share/info/libc.info /usr/share/info/dir
fi

%post -n nscd
/sbin/chkconfig --add nscd

%preun -n nscd
if [ $1 = "0" ] ; then
    /sbin/chkconfig --del nscd
fi

%clean
rm -rf "$RPM_BUILD_ROOT"
rm -f *.filelist*

%files -f rpm.filelist
%defattr(-,root,root)
#%config(noreplace) /etc/localtime
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS
%doc documentation/* README.template README.libm
%doc login/README.utmpd hesiod/README.hesiod
%dir /usr/lib/gconv
%dir /var/db

%files -f devel.filelist devel
%defattr(-,root,root)

%files -f profile.filelist profile
%defattr(-,root,root)

%files -n nscd
%defattr(-,root,root)
%config(noreplace) /etc/nscd.conf
/etc/rc.d/init.d/nscd
/usr/sbin/nscd

%files -n mtrace
%defattr(-,root, root)
/usr/bin/mtrace
